Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2333 by niro, Fri Jan 3 14:00:30 2014 UTC revision 2418 by niro, Tue Jan 7 13:43:24 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10    # ignore the environment
11    LC_ALL=C
12    # include dir
13  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
14    
15  source %SYSCONFDIR%/installer.conf  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16    # -> now in images.conf
17    CURRENTLINE=0
18    
19  #images: (get ${CDIMAGENAME})  die()
20  source /mnt/cdrom/system/images.conf  {
21     echo "Error: $@"
22     exit 1
23    }
24    
25    # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41  source ${INSTALLER_LIBDIR}/functions/findhdd.sh > /dev/null  # -> now in images.conf
42  ### bugfix ###############################  CDIMAGENAME=""
43  cdromdev="$(echo ${cdromdev} | sed 's/ //')"  TOTALLINES=""
44  ########################################  CURRENTLINE=0
45    if [ -e /mnt/cdrom/system/images.conf ]
46    then
47     source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51    else
52     die "/mnt/cdrom/system/images.conf not found"
53    fi
54    
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  CDPATH="${DEFAULT_CDPATH}"  # some sane defaults
60  INSTALLPATH="${DEFAULT_INSTALLPATH}"  CDROOT="${DEFAULT_CDROOT}"
61    INSTALLROOT="${DEFAULT_INSTALLROOT}"
62  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  KERNELPKG="${DEFAULT_KERNELPKG}"
63  CURRENTLINE=0  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 #TOTALLINES=11072 # -> now in images.conf  
   
 # standard kernel opts  
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   ERROR=$1   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78   RETVAL=$?   is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84     exit 1
85    }
86    
87    dialog_die()
88    {
89     ERROR="$1"
90     RETVAL="$?"
91   dialog_install_failure   dialog_install_failure
92   exit 1   exit 1
93  }  }
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
126  {  {
127   local i   local mode
128     local retval
129    
130   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
131   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
132   --title "[ Festplatten Partitionierung ]" \   ":" \
133   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
134   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
135   --stdout \   retval=$?
136   --colors \   [[ ${retval} -eq 1 ]] && return 1
137   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
138   then   then
139   case "${i}" in   case "${mode}" in
140   "1") run_install_auto ;;   "1") run_install_auto ;;
141           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
142   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
143   esac   esac
144   fi   fi
# Line 153  dialog_setup_system_menu() Line 146  dialog_setup_system_menu()
146    
147  dialog_hardware_detection()  dialog_hardware_detection()
148  {  {
149   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
150    
151   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
152    
153   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
154    
155   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
156   then   then
157   for i in ${scsidisks}   for i in ${ALL_DISKS}
158   do   do
159   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
160   done   done
161     message+="\n"
162   fi   fi
163    
164   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
165   then   then
166   for i in ${idedisks}   message+="\n"
167     message+=$"Optical disk drives:\n"
168     for i in ${ALL_CDROMS}
169   do   do
170   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
171   done   done
172   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
173   fi   fi
174    
175   # other devices   # other devices
176   run_hardware_detection   run_hardware_detection
177   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
178   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
179   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
180   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
181   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
182   esac   esac
183   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
184   then   then
185   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"
186   fi   fi
187    
188   echo " \" 14 70" >> ${hwtmp}   messagebox -y 15 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
189  }  }
190    
191  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
192  {  {
193   local i   local i
194    
195   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
196   then   then
197   dialog \   dialog \
198   --backtitle "${TITLE}" \   --backtitle "${TITLE}" \
# Line 248  dialog_setup_hdd_partitions_manuell() Line 208  dialog_setup_hdd_partitions_manuell()
208   echo "--stdout \\" >> /tmp/hddtmp.sh   echo "--stdout \\" >> /tmp/hddtmp.sh
209   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh
210    
211   for i in ${installdevs}   for i in ${ALL_DISKS}
212   do   do
213   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
214   done   done
# Line 261  dialog_setup_hdd_partitions_manuell() Line 221  dialog_setup_hdd_partitions_manuell()
221   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
222   then   then
223   dialog_setup_hdd_info   dialog_setup_hdd_info
224   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
225   fi   fi
226   fi   fi
227  }  }
228    
229  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
230  {  {
231   local i   local i
232    
# Line 298  dialog_setup_hdd_partitions_manuell_flas Line 258  dialog_setup_hdd_partitions_manuell_flas
258   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
259   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
260   then   then
261   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
262   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
263     setup_hdd_partitions_auto
264   fi   fi
265   fi   fi
266  }  }
267    
268  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
269  {  {
270   local i   local bootdev
271    
272   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
273     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
274     # remove the boot device from ALL_DISKS if it was an usbstick
275     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
276   then   then
277   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
278   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
279   fi   fi
280     export ALL_CDROMS="$(get_hwinfo cdrom)"
281  }  }
282    
283  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 431  dialog_main() Line 368  dialog_main()
368   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
369   then   then
370   case ${METHOD} in   case ${METHOD} in
371           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
372   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
373   "3") install_do_reboot ;;   "3") install_do_reboot ;;
374   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 505  hdd_size_below_256mb() Line 442  hdd_size_below_256mb()
442   local hdd="$1"   local hdd="$1"
443   local size   local size
444   local retval   local retval
445   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
446    
447   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
448   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 534  setup_hdd_partitions_auto() Line 471  setup_hdd_partitions_auto()
471   fi   fi
472    
473   ## delete disk   ## delete disk
474   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
475    
476   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
477   then   then
# Line 580  EOF Line 517  EOF
517   fi   fi
518  }  }
519    
520  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
521  {  {
522   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
523    
524   ## hdds partitionieren manuell   ## hdds partitionieren manual
525   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
526  }  }
527    
528  setup_hdd_format()  setup_hdd_format()
529  {  {
530   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
531  }  }
532    
533  install_mount_rootfs()  install_mount_rootfs()
534  {  {
535   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
536   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
537   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
538  }  }
539    
540  install_system_image()  install_system_image()
541  {  {
542   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
543  }  }
544    
545  install_bootsector_chroot()  install_bootsector_chroot()
546  {  {
547   local my_roothdd   local my_roothdd
548   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
549   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
550    
551   # check for grub2   # check for grub2
552   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
553   then   then
554   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
555   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
556   then   then
557   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
558   fi   fi
559    
560   # set kernelopts   # set kernelopts
561   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
562   then   then
563   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
564   else   else
565   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
566   fi   fi
567   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
568   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
569   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
570   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
571    
572   # grub-legacy   # grub-legacy
573   else   else
574   ### grubconf schreiben   ### grubconf schreiben
575   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
576    
577   #for alx only   #for alx only
578   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
579   then   then
580   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
581   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
582   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
583   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
584   fi   fi
# Line 684  install_bootsector_chroot() Line 595  install_bootsector_chroot()
595   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
596   fi   fi
597    
598   : > ${grubconf} || die   : > ${grubconf} || dialog_die
599   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
600   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
601   # using current root password   # using current root password
602   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
603    
604   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
605   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
606   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
607   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
608   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
609   if is_initrd_supported   if is_initrd_supported
610   then   then
611   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
612   fi   fi
613    
614   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
615   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
616   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
617   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
618   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
619   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
620   if is_initrd_supported   if is_initrd_supported
621   then   then
622   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
623   fi   fi
624    
625   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
626   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
627   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
628   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
629   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
630   if is_initrd_supported   if is_initrd_supported
631   then   then
632   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
633   fi   fi
634    
635   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
636   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
637  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
638  root (hd0,0)  root (hd0,0)
639  setup (hd0)  setup (hd0)
# Line 732  exit 0 Line 643  exit 0
643  CHROOTEOF  CHROOTEOF
644   fi   fi
645    
646   ## enters chroot   ## enter chroot
647   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
648   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
649   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
650   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
651   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
652   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
653   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
654   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
655  }  }
656    
657  is_initrd_supported()  is_initrd_supported()
658  {  {
659   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
660   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
661   return 1   return 1
662  }  }
663    
# Line 777  install_initrd_chroot() Line 688  install_initrd_chroot()
688   fi   fi
689    
690   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
691   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
692   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
693    
694   # install an appropriate viafb.conf   # install an appropriate viafb.conf
695   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
696    
697   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
698   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
699    
700   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
701  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
702  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
703  exit 0  exit 0
704  CHROOTEOF  CHROOTEOF
705    
706   ## enters chroot   ## enters chroot
707   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
708   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
709   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
710   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
711   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
712   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
713   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
714   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
715  }  }
716    
717  is_uuid_supported()  is_uuid_supported()
718  {  {
719   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
720   then   then
721   # only detect uuids if supported   # only detect uuids if supported
722   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 824  get_uuid() Line 735  get_uuid()
735   local TYPE   local TYPE
736    
737   local dev="$1"   local dev="$1"
738   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
739    
740   # check if given device is already an UUID   # check if given device is already an UUID
741   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 841  install_system_settings() Line 752  install_system_settings()
752   # schreibe fstab   # schreibe fstab
753   if is_uuid_supported   if is_uuid_supported
754   then   then
755   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
756   else   else
757   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
758   fi   fi
759   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
760   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
761   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
762   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
763    
764   # install network config skeleton   # install network config skeleton
765   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
766    
767   # intel framebufer quirk   # intel framebufer quirk
768   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 863  install_system_settings() Line 772  install_system_settings()
772   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
773   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
774   then   then
775   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
776   fi   fi
777   fi   fi
778   fi   fi
779  }  }
780    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
781  install_umount_rootfs()  install_umount_rootfs()
782  {  {
783   cd /   cd /
784   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
785   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
786  }  }
787    
788  install_do_reboot()  install_do_reboot()
# Line 909  run_install_normal() Line 798  run_install_normal()
798  {  {
799   dialog_hardware_detection   dialog_hardware_detection
800    
801   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
802   dialog_setup_hdd_format   dialog_setup_hdd_format
803   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
804   install_mount_rootfs   install_mount_rootfs
# Line 927  run_install_normal() Line 816  run_install_normal()
816   dialog_install_successful   dialog_install_successful
817  }  }
818    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
819  run_install_auto()  run_install_auto()
820  {  {
821   dialog_hardware_detection   dialog_hardware_detection
822    
823   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
824   dialog_setup_hdd_format   dialog_setup_hdd_format
825   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
826   install_mount_rootfs_flash   install_mount_rootfs
827   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
828    
829   dialog_install_settings   dialog_install_settings
830   sleep 1   sleep 1
831   install_system_settings_flash   install_system_settings
832   install_initrd_chroot   install_initrd_chroot
833    
834   dialog_install_bootsector   dialog_install_bootsector
835   install_bootsector_chroot   install_bootsector_chroot
836    
837   install_umount_rootfs_flash   install_umount_rootfs
838   dialog_install_successful   dialog_install_successful
839  }  }
840    
841    # set some proper traps
842    trap "trap_exit" SIGINT SIGQUIT
843    
844  dialog_main  dialog_main
845    
846  exit 0  exit 0

Legend:
Removed from v.2333  
changed lines
  Added in v.2418